# AC3D
# Copyright (c) 2016, Inivis Limited. All rights reserved.


# spacing between widgets - used inside some gadgets
set bspacing 0

proc create_gadget_utils { utility_frame } {

set entry_width 6

# removed the x y z headers		
if { 0 } {
		set labx [ac_label $utility_frame.labx -text "x" -padding {2 -2 2 -2} ]
		set laby [ac_label $utility_frame.laby -text "y" -padding {2 -2 2 -2} ]
		set labz [ac_label $utility_frame.labz -text "z" -padding {2 -2 2 -2} ]
		grid config $labx -row 0 -column 0 -sticky w
		grid config $laby -row 0 -column 1 -sticky w
		grid config $labz -row 0 -column 2 -sticky w
}
		set com {ac3d move_to  $move_x $move_y $move_z}

        set m1 [ac_create_field_float  $utility_frame.mx move_x "X coordinate" $entry_width $com]
        set m2 [ac_create_field_float  $utility_frame.my move_y "Y coordinate" $entry_width $com]
        set m3 [ac_create_field_float  $utility_frame.mz move_z "Z coordinate" $entry_width $com]
		set mget [ac_button $utility_frame.mget -padding 1 -text "<"  -command { set pos [ac3d get_selection_centre]; set move_x [lindex $pos 0];\
			set move_y [lindex $pos 1];\
			set move_z [lindex $pos 2]} ]
		add_balloon $mget "fill these fields with the current selection centre"

		set mb [cbutton $utility_frame.sb1 "Move to"  $com "Move the centre of the selection to this point"]



		grid config $mget -row 1 -column 3 -sticky e -padx 0
		grid config $m1 -row 1 -column 0 -sticky e -padx 0
		grid config $m2 -row 1 -column 1 -sticky e -padx 0
		grid config $m3 -row 1 -column 2 -sticky e -padx 0
		grid config $mb -row 2 -column 0 -sticky we -pady 0 -columnspan 3
		
		set sp1 [ac_frame $utility_frame.sp1 -height 6 -width 1]
		grid config $sp1 -row 3 -column 0 -sticky e


		set com2 {ac3d size_to  $size_x $size_y $size_z} 

		set s1 [ac_create_field_float  $utility_frame.sx size_x "X width" $entry_width $com2 ]
        set s2 [ac_create_field_float  $utility_frame.sy size_y "Y height" $entry_width $com2 ]
        set s3 [ac_create_field_float  $utility_frame.sz size_z "Z depth" $entry_width $com2 ]
		set sget [ac_button $utility_frame.sget -padding 1 -text "<"  -command { set pos [ac3d get_selection_size]; set size_x [lindex $pos 0];\
			set size_y [lindex $pos 1];\
			set size_z [lindex $pos 2]}]
		add_balloon $sget "fill these fields with the current selection size"

		set sb [cbutton $utility_frame.sb2 "Size to"  $com2 "Size the selection to these dimensions"]



#	set sp1 [label  $utility_frame.sp1 -text " " -pady 0]
#		grid config $sp1 -row 3 -column 0 -sticky e

		grid config $sget -row 5 -column 3 -sticky e
		grid config $s1 -row 5 -column 0 -sticky e
		grid config $s2 -row 5 -column 1 -sticky e
		grid config $s3 -row 5 -column 2 -sticky e
		grid config $sb -row 6 -column 0 -sticky we -pady 0 -columnspan 3

		set sp2 [ac_frame $utility_frame.sp2  -height 6 -width 1]
		grid config $sp2 -row 7 -column 0 -sticky e
		

		# RELATIVE MOVE
		set com3 {ac3d move  $shift_x $shift_y $shift_z}
		set com4 {ac3d move  [expr -($shift_x)] [expr -($shift_y)]  [expr -($shift_z)] }

		set sh1 [ac_create_field_float  $utility_frame.shx shift_x "X distance" $entry_width $com3 $com4]
        set sh2 [ac_create_field_float  $utility_frame.shy shift_y "Y distance" $entry_width $com3 $com4]
        set sh3 [ac_create_field_float  $utility_frame.shz shift_z "Z distance" $entry_width $com3 $com4]
		grid config $sh1 -row 8 -column 0 -sticky e 
		grid config $sh2 -row 8 -column 1 -sticky e
		grid config $sh3 -row 8 -column 2 -sticky e

		set mf [ac_frame $utility_frame.mf ]
		set shl [ac_label $mf.ssl -text "Move"]
		set shb [cbutton $mf.ssh2 "+"  $com3  "Move the selection this distance (add)"]
		set shbm [cbutton $mf.ssh2m "-"  $com4 "Move the selection this distance (subtract)"]
		button_set_autorepeat $shb
		button_set_autorepeat $shbm

		grid config $mf -row 9 -column 0 -columnspan 3 -sticky we
		grid config $shl -row 0 -column 0  -pady 0 
		grid config $shb -row 0 -column 1  -pady 0   -padx 1
		grid config $shbm -row 0 -column 2 -pady 0 -padx 1

#		bind $sh1 <Return> "ttk::button::activate $shb "
#		bind $sh2 <Return> "ttk::button::activate $shb "
#		bind $sh3 <Return> "ttk::button::activate $shb "
#		bind $sh1 <Shift-Return> "ttk::button::activate $shbm "
#		bind $sh2 <Shift-Return> "ttk::button::activate $shbm "
#		bind $sh3 <Shift-Return> "ttk::button::activate $shbm "

		set sp3 [ac_frame $utility_frame.sp3  -height 6 -width 1]
		grid config $sp3 -row 10 -column 0 -sticky e


		# SCALE
        set scalecom {ac3d scale [expr $scale_x/100.0] [expr $scale_y/100.0] [expr $scale_z/100.0]}
		set s1 [ac_create_field_float  $utility_frame.scx scale_x "X scale percentage" $entry_width $scalecom]
        set s2 [ac_create_field_float  $utility_frame.scy scale_y "Y scale percentage" $entry_width $scalecom]
        set s3 [ac_create_field_float  $utility_frame.scz scale_z "Z scale percentage" $entry_width $scalecom]
		set sb [cbutton $utility_frame.sc1 "Scale"  $scalecom "scale the selection\n(100% means there will be no change)"]
		set sl [ac_label $utility_frame.sl -padding 0 -text "%" -justify left -padding 0 ]
		grid config $sl -row 11 -column 3 -sticky w

#		bind $s1 <Return> "ttk::button::activate $sb "
#		bind $s2 <Return> "ttk::button::activate $sb "
#		bind $s3 <Return> "ttk::button::activate $sb "

		grid config $s1 -row 11 -column 0 -sticky e 
		grid config $s2 -row 11 -column 1 -sticky e 
		grid config $s3 -row 11 -column 2 -sticky e
		grid config $sb -row 12 -column 0 -sticky we  -pady 0 -columnspan 3

		set sp4 [ac_frame $utility_frame.sp4  -height 6 -width 1]
		grid config $sp4 -row 13 -column 0 -sticky e

		

		# rotate axis angle
		set rotatecom { axis_selector_do_rotate rotate_axis $rotate_angle }
		set rotatecomminus { axis_selector_do_rotate rotate_axis [expr -($rotate_angle)] }

		# BUG - rotatecom and the other, the validate function is being called after the cbutton is pressed so the rotate_angle var gets the old value


		set rf [ ac_frame $utility_frame.rf ]
		set s2 [ ac_axis_selector $rf.rot rotate_axis]
		set s3 [ ac_create_field_float  $rf.s3 rotate_angle "angle (degrees)" 4 $rotatecom $rotatecomminus]

#		set deg [ac_label $utility_frame.deg -text "" ]
		
		set rbf [ ac_frame $utility_frame.rbf ]
		set srl [ac_label $rbf.srl -text "Rotate"]
		set sb [cbutton $rbf.rb1 "+" $rotatecom "rotate the selection around the selected axis" ]
		set sbm [cbutton $rbf.rb2 "-"  $rotatecomminus "rotate the selection around the selected axis" ]
		button_set_autorepeat $sb
		button_set_autorepeat $sbm
#		bind $s3 <Return> "ttk::button::activate $sb "
#		bind $s3 <Shift-Return> "ttk::button::activate $sbm "


		grid config $rf -row 14 -column 0 -columnspan 4 -sticky w
		grid config $s2 -row 0 -column 0 -padx 2 -sticky w
		grid config $s3 -row 0 -column 1 -padx 0
		
		grid config $rbf -row 15 -column 0 -columnspan 3 -sticky w
		grid config $srl -row 0 -column 0 -sticky we -pady {2 0 } -columnspan 1 -sticky w
		grid config $sb -row 0 -column 1 -sticky we -pady {2 0 } -columnspan 1  -padx 1
		grid config $sbm -row 0 -column 2 -sticky we -pady {2 0 } -columnspan 1  -padx 1

}



proc create_gadget_visibility { f } {
global bspacing UI

	# HIDE/LOCK
	set hide_label [ac_label $f.hide_label -text "Hide" -padding { 0 0 2 0 } ]
    set UI(hide_selected) [cbutton $f.hide_selected "Sel" "ac3d hide_selected" "Hide selected objects from the display"]
    set UI(hide_unselected) [cbutton $f.hide_unselected "Unsel" "ac3d hide_unselected" "Hide objects not selected"]
    set UI(unhide) [cbutton $f.unhide "None" "ac3d unhide" "Restore hidden objects"]

	grid $hide_label  -row 0 -column 0 -sticky we  -padx $bspacing -pady $bspacing
	grid $UI(hide_selected)  -row 0 -column 1 -sticky we  -padx $bspacing -pady $bspacing
	grid $UI(hide_unselected)  -row 0 -column 2 -sticky we -padx $bspacing -pady $bspacing
	grid $UI(unhide) -row 0 -column 3 -sticky we -padx $bspacing -pady $bspacing

	set lock_label [ac_label $f.lock_label -text "Lock" -padding { 0 0 2 0 } ]
    set UI(lock_selected) [cbutton $f.lock_selected "Sel" "ac3d lock_selected" "lock selected objects"]
    set UI(lock_unselected) [cbutton $f.lock_unselected "Unsel" "ac3d lock_unselected" "lock objects not selected"]
    set UI(unlock) [cbutton $f.unlock "None" "ac3d unlock" "Unlock all objects"]

	grid $lock_label  -row 1 -column 0 -sticky we  -padx $bspacing -pady $bspacing
	grid $UI(lock_selected)  -row 1 -column 1 -sticky we -padx $bspacing -pady $bspacing
	grid $UI(lock_unselected) -row 1 -column 2 -sticky we -padx $bspacing -pady $bspacing
	grid $UI(unlock) -row 1 -column 3 -sticky we -padx $bspacing -pady $bspacing

	grid columnconfigure $f 1 -weight 1 
	grid columnconfigure $f 2 -weight 1 
	grid columnconfigure $f 3 -weight 1 
}



proc create_gadget_surface_type { f } {
global bspacing UI

	# SURFACE TYPE
    set sf2 [ac_frame $f.surface_type_frame2 ]

    set UI(function_surface_poly) [cbutton $sf2.function_surface_poly  "Poly"  "ac3d set_surface_type 0"]
    add_balloon $sf2.function_surface_poly "Set selected surfaces to polygons"
    set UI(function_surface_polyline) [cbutton $sf2.function_surface_polyline  "Polyline"  "ac3d set_surface_type 1"]
    add_balloon $sf2.function_surface_polyline "Set selected surfaces to closed lines"
    set UI(function_surface_line) [cbutton $sf2.function_surface_line  "Line"  "ac3d set_surface_type 2"]
    add_balloon $sf2.function_surface_line "Set selected surfaces to lines"
    pack $sf2 $sf2.function_surface_poly $sf2.function_surface_polyline $sf2.function_surface_line \
		 -side left -fill both -expand 1 -pady 0 -padx 0 -ipady 0 -ipadx 0 -padx $bspacing -pady $bspacing

    set sf3 [ac_frame $f.surface_type_frame3 ]
    set UI(function_surface_smooth) [ cbutton $sf3.function_surface_smooth "Smooth" "ac3d surface_set_shaded 1 "]
    add_balloon $sf3.function_surface_smooth "Set smooth-shaded surfaces"
    set UI(function_surface_flat) [cbutton $sf3.function_surface_flat "Flat" "ac3d surface_set_shaded 0 "]
    add_balloon $sf3.function_surface_flat "Set flat-shaded surfaces"
    set UI(function_surface_one_sided) [ cbutton $sf3.function_surface_one_sided "1S" "ac3d surface_set_twosided 0 "]
    add_balloon $sf3.function_surface_one_sided "Set single-sided surfaces"
    set UI(function_surface_two_sided) [cbutton $sf3.function_surface_two_sided "2S"  "ac3d surface_set_twosided 1"]
    add_balloon $sf3.function_surface_two_sided "Set double-sided surfaces"

    pack $sf3.function_surface_smooth $sf3.function_surface_flat $sf3.function_surface_one_sided $sf3.function_surface_two_sided \
		-side left -fill both -expand 1 -pady 0 -padx 0 -ipady 0 -ipadx 0 -padx $bspacing -pady $bspacing

    vert_pack $f $sf2 $sf3
}

proc create_gadget_palette { f } {

	# the palette
	make_palette $f.c
	pack $f.c -side top -fill x

}

proc create_gadget_object_name { f } {
global UI

	# object name

    set UI(current_object_name_entry) [ac_entry $f.current_object_name_entry -textvariable current_object_name]
    bind $UI(current_object_name_entry) <KeyRelease> {
        ac3d set_current_object_name $current_object_name
        hier_update
        }

    pack $UI(current_object_name_entry)\
        -side left -fill x -expand 1 -pady 0

}



proc create_gadget_extrude { f } {
global prefs_extrude_num prefs_extrude_normal_distance

    ac_create_pair_label_spinbox $f prefs_extrude_num "Sections" "number sections in extrude" 3 1 999

	set extrude_entry_width 6
    ac_create_pair_label_entry_float  $f extrudex "x" "X distance" $extrude_entry_width
    ac_create_pair_label_entry_float  $f extrudey "y" "Y distance" $extrude_entry_width
    ac_create_pair_label_entry_float  $f extrudez "z" "Z distance" $extrude_entry_width

	ac_create_pair_button $f "Extrude by distance"  {ac3d extrude_dist $extrudex $extrudey $extrudez $prefs_extrude_num } "extrude now with the above distance and all of the above settings"

	ac_create_pair_spacer $f 

    ac_create_pair_label_entry  $f prefs_extrude_normal_distance "Dist" "Distance" $extrude_entry_width
	ac_create_pair_button $f "Extrude by normal"  {ac3d extrude_normal_dist $prefs_extrude_normal_distance 1 } "extrude in the direction of the surface-normals"
}








ac3d add_pref window_geom_replcator ""





proc create_replicator_gadget { p } {
global rep_num rotx roty rotz movex movey movez scalex scaley scalez about replicator_dup
global ac_platform

 
    set rep_num 1
    set rotx 0
    set roty 0
    set rotz 0
    set movex 0
    set movey 0
    set movez 0
    set scalex 1.0
    set scaley 1.0
    set scalez 1.0
	# rotate about origin as default
    set about 2
	set replicator_dup duplicate

	set padx 0
	set ipadx 0

#    ac_frame $p.num
#    ac_label $p.lab -text "Copies"
#	grid $p.lab -row 0 -column 0 -sticky e -padx $padx -ipadx $ipadx
#	ac_spinbox $p.num.val -textvariable rep_num -from 1 -to 999 -increment 1 -width 4
#	grid $p.num.val -row 1 -column 1 -sticky w
#	grid $p.num -row 0 -column 1  -sticky w -padx $padx -ipadx $ipadx

	ac_create_pair_label_spinbox $p rep_num "Copies" "Number of copies/iterations" 4 1 999


	set af [ ac_create_pair_label_frame $p "Action" ]
	ac_create_radiobutton_strip $af.dup replicator_dup { Duplicate Extrude } { duplicate extrude } { }
	pack $af.dup
			
#	ac_label $p.dupl -text "Action"
#	grid $p.dupl -row 2 -column 0 -sticky e -padx $padx -ipadx $ipadx
#	ac_create_radiobutton_strip $p.dup replicator_dup { Duplicate Extrude } { duplicate extrude } { }
#	grid $p.dup -row 2 -column 1 -sticky w -padx $padx -ipadx $ipadx


	ac_create_pair_label_triple_float $p "Move" "Movement per iteration" 6 movex movey movez

#    ac_frame $p.move 
#    ac_label $p.lab2 -text "Move"
#    grid $p.lab2 -row 3 -column 0  -sticky e -padx $padx -ipadx $ipadx
#    ac_entry  $p.move.x -textvariable movex  -width 6
#    pack $p.move.x -side left
#    ac_entry  $p.move.y  -textvariable movey  -width 6
#    pack $p.move.y -side left
#    ac_entry  $p.move.z -textvariable movez  -width 6
#    pack $p.move.z -side left
#    grid $p.move -row 3 -column 1 -sticky w -padx $padx -ipadx $ipadx


#    ac_frame $p.rot
#    ac_label $p.lab3 -text "Rotate"
#    grid $p.lab3 -row 4 -column 0 -sticky e -padx $padx -ipadx $ipadx
#    ac_entry  $p.rot.x -textvariable rotx -width 6
#    grid $p.rot.x -row 0 -column 0 -sticky we
#    ac_entry  $p.rot.y  -textvariable roty -width 6
#    grid $p.rot.y -row 0 -column 1 -sticky we
#    ac_entry  $p.rot.z  -textvariable rotz  -width 6
#    grid $p.rot.z -row 0 -column 2 -sticky we
#    grid $p.rot -row 4 -column 1 -sticky w -padx $padx -ipadx $ipadx

	ac_create_pair_label_triple_float $p "Rotation" "Rotation per iteration" 6 rotx roty rotz


	set abf [ ac_create_pair_label_frame $p "Rotate about" ]
	pack [ ac_create_radiobutton_strip $abf.about about { Origin Selection "3D Cursor"} { 2 0 1 } ]



#    ac_label $p.lab4 -text "Rotate about"
#    grid $p.lab4 -row 5 -column 0 -sticky ne -padx $padx -ipadx $ipadx
#	ac_create_radiobutton_strip $p.about about { Origin Selection "3D Cursor"} { 2 0 1 } 
#   grid $p.about -row 5 -column 1 -sticky w -padx $padx -ipadx $ipadx


#    ac_frame $p.scale
#    ac_label $p.lab5 -text "Scale"
#	grid $p.lab5 -row 6 -column 0 -sticky e -padx $padx -ipadx $ipadx
#    ac_entry  $p.scale.x -textvariable scalex -width 6
#    pack $p.scale.x -side left
#    ac_entry  $p.scale.y  -textvariable scaley -width 6
#    pack $p.scale.y -side left
#    ac_entry  $p.scale.z  -textvariable scalez  -width 6
#    pack $p.scale.z -side left
#    grid $p.scale -row 6 -column 1 -sticky w -padx $padx -ipadx $ipadx

	ac_create_pair_label_triple_float $p "Scale" "Scale factors per iteration" 6 scalex scaley scalez

#	grid rowconfigure $p "all" -pad 2

#	ac_frame $p.bf
#    ac_button $p.bf.replicate -text "Go" -command send_replicate;
#    pack $p.bf.replicate  -side left -expand 1 -padx 3m -pady 2m
#	grid $p.bf -row 7 -column 0 -columnspan 2

	ac_create_pair_button $p "   Go   " send_replicate ""
	

	proc send_replicate {} {
	global dest
	global rep_num
	global rotx
	global roty
	global rotz
	global movex
	global movey
	global movez
	global scalex
	global scaley
	global scalez
	global about replicator_dup
	global select_mode prefs_extrude_cap_end
	global prefs_allow_redraws

		if { ( $replicator_dup == "extrude" ) && ( ($select_mode != "surface") && ($select_mode != "vertex") ) } {
				tk_messageBox -type ok -title "AC3D replicator" -message \
					"Extruding works only in Surface or Vertex select mode.\n\nPlease change the select mode."

				return;
		}


		for { set n 0 } { $n < $rep_num } { incr n } {
 
			set prefs_allow_redraws false
			if { $replicator_dup == "duplicate" } {
				ac3d clone_selection
			} else {
				set tempcap $prefs_extrude_cap_end
				set prefs_extrude_cap_end true
				# hack - set extrude dist to very small number so vertices aren't all optimized.
				# part 2 of the hack is moving the extruded stuff back 0.0001 in the move part of the replicate, just below here
				ac3d extrude_dist 0.0001 0.0001 0.0001 1
				set prefs_extrude_cap_end $tempcap
			}

#			if { ( ($movex != 0 ) || ($movey != 0) || ($movez != 0)) } {
				ac3d move [expr $movex-0.0001] [expr $movey-0.0001] [expr $movez-0.0001]
#			}

			if {$about == 0} {
				if { ( ($rotx != 0 ) || ($roty != 0) || ($rotz != 0)) } {
					ac3d rotate $rotx $roty $rotz
				}
			} elseif {$about == 1} {
				if { ( ($rotx != 0 ) || ($roty != 0) || ($rotz != 0)) } {
					set cursor [ac3d get_3d_cursor]
					ac3d rotate_about $rotx $roty $rotz [lindex $cursor 0] [lindex $cursor 1] [lindex $cursor 2]
				}
			} else {
				if { ( ($rotx != 0 ) || ($roty != 0) || ($rotz != 0)) } {
					ac3d rotate_about $rotx $roty $rotz 0 0 0
				}
			} 
        
			if { ( ($scalex != 1.0 ) || ($scaley != 1.0) || ($scalez != 1.0)) } {
				ac3d scale $scalex $scaley $scalez;
			}

			set prefs_allow_redraws true
			ac3d redraw_all
		}

    ac3d redraw_all
	}

}






proc menu_replicator {} {

	set t [ ac_toplevel_with_close .relicator "Replicator" "create_replicator_gadget" ]

}






###############################################################

# UIGADGETLIST is a list of unique ids (must have no spaces because it's used as the child windowid)
# esch id has a related UIGADGET with various stuff includig the constructor proc which creates the widgets
# UGADGETWIN() stores windowid->gadgetid


proc add_ui_gadget {  id title constructor } {
global UIGADGET UIGADGETLIST

	lappend UIGADGETLIST $id
	set UIGADGET($id.title) $title
	set UIGADGET($id.constructor) $constructor

#	puts "UIGADGETLIST $UIGADGETLIST"
	set UIGADGETLIST [ lsort $UIGADGETLIST ]
#	puts "UIGADGETLIST SORTED $UIGADGETLIST"
}

proc build_gadget { id parent { isopen 0 } } {
global UIGADGET UIGADGETWIN

	set title $UIGADGET($id.title)

	set outer [ FoldFrame:create $parent.$id $title $isopen]
	set container [FoldFrame:get_container $outer]
	FoldFrame:set_dragable $outer

	# call the construtor to create the widgets
	$UIGADGET($id.constructor) $container

	# record the outer window in the UIGADGET structure
	set UIGADGET($id.window) $outer

	# this allows us to get the gadgetid from the window
	set UIGADGETWIN($outer) $id

	# pack it for now
#	pack $outer -side top -fill x -expand 1

	return $outer
}

proc get_gadget_layout { } {
global UI UIGADGETLIST UIGADGET UIGADGETWIN

#	foreach gid $UIGADGETLIST {
#		puts "GADGET $gid"
#		puts "title: $UIGADGET($gid.title)"
#		puts "constructor: $UIGADGET($gid.constructor)"
#	}

	# the parent of all the gadgets
	set win $UI(gadget_frame)

	# read the chldren of the gadget frame
	# "pack slaves" must be used (winfo children doesn't return the visible packing order)
	set kids [pack slaves $win]

	set glist ""
	foreach  k $kids { 
#		puts "child $k"
#		puts "id = $UIGADGETWIN($k)"
		set gid $UIGADGETWIN($k)
		set isopen [ FoldFrame:is_open $k ]
#		puts "isopen $isopen"

		lappend glist $gid
		lappend glist $isopen
	}

#	puts "FINAL $glist"
	return $glist
}


# for testing we just build them all.  idealy build them all unmapped, get a list of the ones to map in the right order
# from prefs and then map those.  Also, some may be open/folded




proc build_gadgets { control_panel } {
global UIGADGETLIST UIGADGET prefs_ui_gadget_layout

	# adds them all but they will be unmapped.
	# it's important to build them all because some react to global variables and sensitivity changes.
	# it would cause problems if those widgets didn't exist
	 
	foreach gid $UIGADGETLIST {
#		puts "BUILDGADGET $gid"
		build_gadget $gid $control_panel 0

#		set win $UIGADGET($gid.window)
#		pack $win -side top -fill x -expand 1

		}


	# go through pref list of gadgets that are visible
	foreach { gid isopen } $prefs_ui_gadget_layout {
#		puts "MAPGADGET $gid $isopen"
		set win $UIGADGET($gid.window)

		#need to ensure the folding frame is open or closed 
		FoldFrame:set_open $win $isopen

		# map the folding widget
		pack $win -side top -fill x -expand 1
		}



}


add_ui_gadget "replicator" "Replicator" create_replicator_gadget


add_ui_gadget "utils" "Utils" create_gadget_utils
add_ui_gadget "visibility" "Visibility" create_gadget_visibility
add_ui_gadget "surfacetype" "Set Surface Type" create_gadget_surface_type
add_ui_gadget "palette" "Palette" create_gadget_palette
add_ui_gadget "objectname" "Object name" create_gadget_object_name
add_ui_gadget "extrude" "Extrude Numeric" create_gadget_extrude